Open CASCADE Technology: TDataXtd_Axis Class Reference

Open CASCADE Technology 6.8.0

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions | Static Public Member Functions
TDataXtd_Axis Class Reference

The basis to define an axis attribute. More...

`#include <TDataXtd_Axis.hxx>`

Inheritance diagram for TDataXtd_Axis:
[legend]

## Public Member Functions
| TDataXtd_Axis ()
const Standard_GUID & | ID () const
| Returns the ID of the attribute. More...
void | Restore (const Handle< TDF_Attribute > &with)
| Restores the backuped contents from <anAttribute> into this one. It is used when aborting a transaction. More...
Handle< TDF_Attribute > | NewEmpty () const
| Returns an new empty attribute from the good end type. It is used by the copy algorithm. More...
void | Paste (const Handle< TDF_Attribute > &into, const Handle< TDF_RelocationTable > &RT) const
| This method is different from the "Copy" one, because it is used when copying an attribute from a source structure into a target structure. This method may paste the contents of <me> into <intoAttribute>. More...
virtual Standard_OStream & | Dump (Standard_OStream &anOS) const
| Dumps the minimum information about <me> on <aStream>. More...
Public Member Functions inherited from TDF_Attribute
const TDF_Label | Label () const
| Returns the label to which the attribute is attached. If the label is not included in a DF, the label is null. See Label. Warning If the label is not included in a data framework, it is null. This function should not be redefined inline. More...
Standard_Integer | Transaction () const
| Returns the transaction index in which the attribute has been created or modified. More...
Standard_Integer | UntilTransaction () const
| Returns the upper transaction index until which the attribute is/was valid. This number may vary. A removed attribute validity range is reduced to its transaction index. More...
Standard_Boolean | IsValid () const
| Returns true if the attribute is valid; i.e. not a backuped or removed one. More...
Standard_Boolean | IsNew () const
| Returns true if the attribute has no backup. More...
Standard_Boolean | IsForgotten () const
| Returns true if the attribute forgotten status is set. More...
Standard_Boolean | IsAttribute (const Standard_GUID &anID) const
| Returns true if it exists an associated attribute of <me> with <anID> as ID. More...
Standard_Boolean | FindAttribute (const Standard_GUID &anID, Handle< TDF_Attribute > &anAttribute) const
| Finds an associated attribute of <me>, according to <anID>. the returned <anAttribute> is a valid one. The method returns True if found, False otherwise. A removed attribute cannot be found using this method. More...
void | AddAttribute (const Handle< TDF_Attribute > &other) const
| Adds an Attribute <other> to the label of <me>.Raises if there is already one of the same GUID fhan <other>. More...
Standard_Boolean | ForgetAttribute (const Standard_GUID &aguid) const
| Forgets the Attribute of GUID <aguid> associated to the label of <me>. Be carefull that if <me> is the attribute of <guid>, <me> will have a null label after this call. If the attribute doesn't exist returns False. Otherwise returns True. More...
void | ForgetAllAttributes (const Standard_Boolean clearChildren=Standard_True) const
| Forgets all the attributes attached to the label of <me>. Does it on the sub-labels if <clearChildren> is set to true. Of course, this method is compatible with Transaction & Delta mecanisms. Be carefull that if <me> will have a null label after this call. More...
virtual void | AfterAddition ()
| Something to do after adding an Attribute to a label. More...
virtual void | BeforeRemoval ()
| Something to do before removing an Attribute from a label. More...
virtual void | BeforeForget ()
| Something to do before forgetting an Attribute to a label. More...
virtual void | AfterResume ()
| Something to do after resuming an Attribute from a label. More...
virtual Standard_Boolean | AfterRetrieval (const Standard_Boolean forceIt=Standard_False)
| Something to do AFTER creation of an attribute by persistent-transient translation. The returned status says if AfterUndo has been performed (true) or if this callback must be called once again further (false). If <forceIt> is set to true, the method MUST perform and return true. Does nothing by default and returns true. More...
virtual Standard_Boolean | BeforeUndo (const Handle< TDF_AttributeDelta > &anAttDelta, const Standard_Boolean forceIt=Standard_False)
| Something to do before applying <anAttDelta>. The returned status says if AfterUndo has been performed (true) or if this callback must be called once again further (false). If <forceIt> is set to true, the method MUST perform and return true. Does nothing by default and returns true. More...
virtual Standard_Boolean | AfterUndo (const Handle< TDF_AttributeDelta > &anAttDelta, const Standard_Boolean forceIt=Standard_False)
| Something to do after applying <anAttDelta>. The returned status says if AfterUndo has been performed (true) or if this callback must be called once again further (false). If <forceIt> is set to true, the method MUST perform and return true. Does nothing by default and returns true. More...
virtual void | BeforeCommitTransaction ()
| A callback. By default does nothing. It is called by TDF_Data::CommitTransaction() method. More...
void | Backup ()
| Backups the attribute. The backuped attribute is flagged "Backuped" and not "Valid". More...
Standard_Boolean | IsBackuped () const
| Returns true if the attribute backup status is set. This status is set/unset by the Backup() method. More...
virtual Handle< TDF_Attribute > | BackupCopy () const
| Copies the attribute contents into a new other attribute. It is used by Backup(). More...
virtual Handle < TDF_DeltaOnAddition > | DeltaOnAddition () const
| Makes an AttributeDelta because <me> appeared. The only known use of a redefinition of this method is to return a null handle (no delta). More...
virtual Handle< TDF_DeltaOnForget > | DeltaOnForget () const
| Makes an AttributeDelta because <me> has been forgotten. More...
virtual Handle< TDF_DeltaOnResume > | DeltaOnResume () const
| Makes an AttributeDelta because <me> has been resumed. More...
virtual Handle < TDF_DeltaOnModification > | DeltaOnModification (const Handle< TDF_Attribute > &anOldAttribute) const
| Makes a DeltaOnModification between <me> and <anOldAttribute. More...
virtual void | DeltaOnModification (const Handle< TDF_DeltaOnModification > &aDelta)
| Applies a DeltaOnModification to <me>. More...
virtual Handle < TDF_DeltaOnRemoval > | DeltaOnRemoval () const
| Makes a DeltaOnRemoval on <me> because <me> has disappeared from the DS. More...
virtual void | References (const Handle< TDF_DataSet > &aDataSet) const
| Adds the first level referenced attributes and labels to <aDataSet>. More...
Standard_OStream & | operator<< (Standard_OStream &anOS) const
virtual void | ExtendedDump (Standard_OStream &anOS, const TDF_IDFilter &aFilter, TDF_AttributeIndexedMap &aMap) const
| Dumps the attribute content on <aStream>, using <aMap> like this: if an attribute is not in the map, first put add it to the map and then dump it. Use the map rank instead of dumping each attribute field. More...
void | Forget (const Standard_Integer aTransaction)
| Forgets the attribute. <aTransaction> is the current transaction in which the forget is done. A forgotten attribute is also flagged not "Valid". More...
Public Member Functions inherited from MMgt_TShared
virtual void | Delete () const
| Memory deallocator for transient classes. More...
Public Member Functions inherited from Standard_Transient
| Standard_Transient ()
| Empty constructor. More...
| Standard_Transient (const Standard_Transient &)
| Copy constructor – does nothing. More...
Standard_Transient & | operator= (const Standard_Transient &)
| Assignment operator, needed to avoid copying reference counter. More...
virtual | ~Standard_Transient ()
| Destructor must be virtual. More...
virtual const Handle_Standard_Type & | DynamicType () const
| Returns a type information object about this object. More...
Standard_Boolean | IsInstance (const Handle_Standard_Type &theType) const
| Returns a true value if this is an instance of Type. More...
Standard_Boolean | IsInstance (const Standard_CString theTypeName) const
| Returns a true value if this is an instance of TypeName. More...
Standard_Boolean | IsKind (const Handle_Standard_Type &theType) const
| Returns true if this is an instance of Type or an instance of any class that inherits from Type. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
Standard_Boolean | IsKind (const Standard_CString theTypeName) const
| Returns true if this is an instance of TypeName or an instance of any class that inherits from TypeName. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
virtual Handle_Standard_Transient | This () const
| Returns a Handle which references this object. Must never be called to objects created in stack. More...
Standard_Integer | GetRefCount () const
| Get the reference counter of this object. More...

## Static Public Member Functions
static const Standard_GUID & | GetID ()
| # class methods Returns the GUID for an axis. More...
static Handle< TDataXtd_Axis > | Set (const TDF_Label &label)
| Finds or creates an axis attribute defined by the label. In the case of a creation of an axis, a compatible named shape should already be associated with label. Exceptions Standard_NullObject if no compatible named shape is associated with the label. More...
static Handle< TDataXtd_Axis > | Set (const TDF_Label &label, const gp_Lin &L)
| Find, or create, an Axis attribute and set. More...

## Additional Inherited Members
Protected Member Functions inherited from TDF_Attribute
| TDF_Attribute ()
| Initializes fields. More...

## Detailed Description

The basis to define an axis attribute.

Warning: Use TDataXtd_Geometry attribute to retrieve the gp_Lin of the Axis attribute

## Constructor & Destructor Documentation

TDataXtd_Axis::TDataXtd_Axis | ( |  | ) |

## Member Function Documentation

virtual Standard_OStream& TDataXtd_Axis::Dump | ( | Standard_OStream & | anOS | ) | const
| virtual

Dumps the minimum information about <me> on <aStream>.

Reimplemented from TDF_Attribute.

static const Standard_GUID& TDataXtd_Axis::GetID | ( |  | ) |
| static

# class methods

Returns the GUID for an axis.

const Standard_GUID& TDataXtd_Axis::ID | ( |  | ) | const
| virtual

Returns the ID of the attribute.

Implements TDF_Attribute.

Handle< TDF_Attribute > TDataXtd_Axis::NewEmpty | ( |  | ) | const
| virtual

Returns an new empty attribute from the good end type. It is used by the copy algorithm.

Implements TDF_Attribute.

void TDataXtd_Axis::Paste | ( | const Handle< TDF_Attribute > & | intoAttribute,
|  | const Handle< TDF_RelocationTable > & | aRelocationTable
| ) |  | const
| virtual

This method is different from the "Copy" one, because it is used when copying an attribute from a source structure into a target structure. This method may paste the contents of <me> into <intoAttribute>.

The given pasted attribute can be full or empty of its contents. But don't make a NEW! Just set the contents!

It is possible to use <aRelocationTable> to get/set the relocation value of a source attribute.

Implements TDF_Attribute.

void TDataXtd_Axis::Restore | ( | const Handle< TDF_Attribute > & | anAttribute | ) |
| virtual

Restores the backuped contents from <anAttribute> into this one. It is used when aborting a transaction.

Implements TDF_Attribute.

static Handle< TDataXtd_Axis > TDataXtd_Axis::Set | ( | const TDF_Label & | label | ) |
| static

Finds or creates an axis attribute defined by the label. In the case of a creation of an axis, a compatible named shape should already be associated with label. Exceptions Standard_NullObject if no compatible named shape is associated with the label.

static Handle< TDataXtd_Axis > TDataXtd_Axis::Set | ( | const TDF_Label & | label,
|  | const gp_Lin & | L
| ) |  |
| static

Find, or create, an Axis attribute and set.

as generated in the associated NamedShape.

# Axis methods

The documentation for this class was generated from the following file:

- TDataXtd_Axis.hxx